function [points, intensities] = disparity2PointCloud(...
    disp_img, K, baseline, left_img)
% TODO: determine 3D point cloud for disparity image in camera frame
% conventions:
% - points should ba 3xN matrix for N number of pixels with valid disparity
% - intensities are 1xN matrix with grey values of the corresponding pixels
% - only pixels with valid disparity should be included into the point
% cloud

nb_valid = 0;

width = size(left_img, 2);
height = size(left_img, 1);

points = zeros(3, width * height);
intensities = zeros(1, width * height);

bf = baseline * K(1, 1);

for v = 1 : height
    for u = 1 : width
        if disp_img(v, u) == 0
            continue;
        end
        
        nb_valid = nb_valid + 1;
        depth = bf / disp_img(v, u);
        points(:, nb_valid) = K \ [u, v, 1]' * depth;
        intensities(1, nb_valid) = left_img(v, u);        
    end
end

end

