function [points, intensities] = disparity2PointCloud(...
    disp_img, K, baseline, left_img)
% TODO: determine 3D point cloud for disparity image in camera frame
% conventions:
% - points should ba 3xN matrix for N number of pixels with valid disparity
% - intensities are 1xN matrix with grey values of the corresponding pixels
% - only pixels with valid disparity should be included into the point
% cloud

[imgHeight, imgWidth] = size(left_img);


depthimg = zeros(imgHeight,imgWidth);

f = 359.428;

points = zeros(3, size(disp_img,1)*size(disp_img,2));
intensities = zeros(1, size(disp_img,1)*size(disp_img,2));
n = 1;
 for i = 1 : imgHeight
     for j = 1 : imgWidth
         di = disp_img(i,j);
         if(di > 0)
             depth = baseline*f/di;
             x = depth*i/f;
             y = depth*j/f;
             points(:,n) = [x, y, depth];
             intensities(:,n) = left_img(i,j);
             depthimg(i,j) = baseline*f/di;
             n = n + 1;
         else
             depthimg(i,j)=0;
         end
     end
 end

 depthimg = 256.*(depthimg - min(depthimg))./(max(depthimg) - min(depthimg));
 %imagesc(depthimg);
 
 %depthimg = rescale(depthimg, 0, 255);

end

